;ztt4clause.lst
;Copyright (C) 2004-2005 by C. Bradford Barber
;$Id: //product/ttcnf/main/src/ztt4clau.asm#1 $
;$DateTime: 2008/03/16 14:47:31 $$Change: 844 $$Author: bbarber $

	include tt_all.sym

;;update counts for all clauses of TruthTable
;
;	DL= NumVar -- see above
;	DH= NumCNF
;	ESI= TruthTable after m CNF clauses
;	EDI= TruthTables
;returns:
;	C set if ttwas0
;	EAX= TotSame
;	EBX,ESI,EDI preserved
; 
;group: truth.-table
; call: ztt4cnf
; xref: zttclause ztt4cnf0

aa@a		equ 0FF00FF00h
aa@b		equ 0F0F0F0F0h
aa@c		equ 0CCCCCCCCh
aa@d		equ 0AAAAAAAAh
aa@0		equ 000000000h
;zttcnf0 handles varE explicitly

  ;proccallx <all>,<edx,di,si>,'ztt4clause: update counts for all clauses of TruthTable @di.hex.si.hex' 

tt_setAllClause_c PROC
  pushm	ebx,esi,edi,ebp ;preserved
  NOTE	regebp ;used for ztt4cnf0
  mov	ebp,ttcompmask
  ifzero edx
  jz	aa@testret
  mov	al,dl ;NumVar
  sub	al,dh
  jb	aa@cnferr
  cmp	al,4
  ja	aa@cnferr
  cmp	dh,1
  je	aa@run1
  cmp	dh,2
  je	aa@run2
  cmp	dh,3
  je	aa@run3
  cmp	dh,4
  je	aa@run4
  cmp	dh,5
  ja	aa@cnferr
  or	ebp,ttvarE
aa@run4:
aa@repeat4:
  push	edx
  mov	eax,aa@a
  mov	ebx,aa@b
  mov	ecx,aa@c
  mov	edx,aa@d
  call ztt4cnf0 ;si,di,xes,>was0
  pop	edx
  cmp	dh,dl ;505 or 404
  je	aa@testret
  test	ebp,ttvarE
  jz	aa@not506
  and	ebp,not ttvarE
  jmp	aa@repeat4
aa@not506:
  or	ebp,ttvarE 
aa@run3:
  mov	eax,aa@0
  and	ebp,not 080000000h ;high bit of ttcompmask
  check ttcompmask,eq,0F0000000h 
aa@repeat3:
  push	edx
  mov	ebx,aa@b
  mov	ecx,aa@c
  mov	edx,aa@d
  EXTRN ztt4cnf0:near
  call	ztt4cnf0 ;ax,si,di,xes,>was0
  pop	edx
  cmp	dl,03h
  je	aa@testret ;0303
  push	edx
  mov	ebx,aa@a
  mov	ecx,aa@b
  mov	edx,aa@c
  call	ztt4cnf0 ;ax,si,di,xes,>was0
  mov	ebx,aa@a
  mov	ecx,aa@b
  mov	edx,aa@d
  call	ztt4cnf0 ;ax,si,di,xes,>was0
  mov	ebx,aa@a
  mov	ecx,aa@c
  mov	edx,aa@d
  call	ztt4cnf0 ;ax,si,di,xes,>was0
  pop	edx
  mov	cl,dl 
  sub	cl,dh
  dec	cl
  jz	aa@testret ;0304, 0405, 0506
  test	ebp,ttvarE
  jz	aa@not406
  and	ebp,not ttvarE
  jmp	aa@repeat3
aa@not406:
  or	ebp,ttvarE
aa@run2:
  mov	eax,aa@0
  mov	ebx,aa@0
  and	ebp,not 0C0000000h ;top 2 bits of ttcompmask
  check ttcompmask,eq,0F0000000h 
aa@repeat2:
  push	edx
  mov	ecx,aa@c
  mov	edx,aa@d
  call	ztt4cnf0 ;ax,bx,si,di,xes,>was0
  pop	edx
  cmp	dl,02h
  je	aa@testret ;0202
  push	edx
  mov	ecx,aa@b
  mov	edx,aa@c
  call	ztt4cnf0 ;ax,bx,si,di,xes,>was0
  mov	ecx,aa@b
  mov	edx,aa@d
  call	ztt4cnf0 ;ax,bx,si,di,xes,>was0
  pop	edx
  cmp	dl,03h
  je	aa@testret ;0203
  push	edx
  mov	ecx,aa@a
  mov	edx,aa@b
  call	ztt4cnf0 ;ax,bx,si,di,xes,>was0
  mov	ecx,aa@a
  mov	edx,aa@c
  call	ztt4cnf0 ;ax,bx,si,di,xes,>was0
  mov	ecx,aa@a
  mov	edx,aa@d
  call	ztt4cnf0 ;ax,bx,si,di,xes,>was0
  pop	edx
  mov	cl,dl 
  sub	cl,dh
  cmp	cl,2
  je	aa@testret ;0204, 0305, 0406, 0507
  test	ebp,ttvarE
  jz	aa@not407
  and	ebp,not ttvarE
  jmp	aa@repeat2
aa@not407:
  or	ebp,ttvarE
aa@run1:
  mov	eax,aa@0
  mov	ebx,aa@0
  mov	ecx,aa@0
  and	ebp,not 0E0000000h ;top 3 bits of ttcompmask
  check ttcompmask,eq,0F0000000h 
aa@repeat1:
  push	edx
  mov	edx,aa@d
  call	ztt4cnf0 ;ax,bx,cx,si,di,xes,>was0
  pop	edx
  cmp	dl,01h
  je	aa@testret ;0101
  push	edx 
  mov	edx,aa@c
  call	ztt4cnf0 ;ax,bx,cx,si,di,xes,>was0
  pop	edx
  cmp	dl,02h
  je	aa@testret ;0102
  push	edx 
  mov	edx,aa@b
  call	ztt4cnf0 ;ax,bx,cx,si,di,xes,>was0
  pop	edx
  cmp	dl,03h
  je	aa@testret ;0103
  push	edx 
  mov	edx,aa@a
  call	ztt4cnf0 ;ax,bx,cx,si,di,xes,>was0
  pop	edx
  mov	cl,dl 
  sub	cl,dh
  cmp	cl,3
  je	aa@testret ;0104, 0205, 0306, 0407, 0508
  clear	ecx
  test	ebp,ttvarE
  jz	aa@not408
  and	ebp,not ttvarE
  jmp	aa@repeat1
aa@not408:
  or	ebp,ttvarE
  and	ebp,not 0F0000000h ;top 4 bits of ttcompmask (i.e., varE only)
  check ttcompmask,eq,0F0000000h 
  mov	edx,aa@0
  call	ztt4cnf0 ;si,di,xes,>was0 (C)
aa@testret:
  mov	eax,ebp
  cmp	ax,ttmaxclause
  ja	aa@errmax
  and	eax,ttsamemask
  shl	ebp,6
  check	ttwas0,eq,04000000h  ;set C
  popm	ebp,edi,esi,ebx ;preserved
  ret	;ret OK -- end of tt_setAllClause_c

  ;procretx <all>,<f>,'ztt4clause: was0 @C'

aa@cnferr:
  DSstr esi,'tt_setAllClause_c (002252h): cnf %d is not supported.'
  pushm edx,esi,tt_ERRrun
  invoke tt_errexit 

aa@errmax:
  and eax,0ffffh
  DSstr esi,'tt_setAllClause_c (002253h): count (%d) of same clauses for one step larger than expected.  Code is wrong.'
  pushm eax,esi,tt_ERRrun
  invoke tt_errexit 

tt_setAllClause_c ENDP

  END